classification
Title: Always running kill_python breaks building x64 on 32-bit Windows machine
Type: compile error Stage: resolved
Components: Build Versions: Python 3.4, Python 3.3
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: zach.ware Nosy List: python-dev, sdeibel, tim.peters, zach.ware
Priority: normal Keywords: patch

Created on 2014-02-12 14:26 by sdeibel, last changed 2014-03-17 06:31 by python-dev. This issue is now closed.

Files
File name Uploaded Description Edit
issue20609.diff zach.ware, 2014-02-12 17:49 review
Messages (10)
msg211093 - (view) Author: Stephan R.A. Deibel (sdeibel) Date: 2014-02-12 14:26
The changes made in Issue19788 break the ability to build x64 build target on a 32-bit Windows machine because PreBuildEvent entries in pythoncore.vcxproj end up trying to run the 64-bit kill_python.exe, causing critical build steps to fail.  Removing those PreBuildEvents by manually editing pythoncore.vcxproj served as a work-around.
msg211107 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2014-02-12 17:37
Oops...

Can you try out this patch and see if it will work for you?  It looks like it should work, but I'm not set up to build 64-bit at all yet, much less on 32-bit.

Tim, would you mind also taking a look since you tested #19788 for me and we're in RC for 3.4?
msg211108 - (view) Author: Stephan R.A. Deibel (sdeibel) Date: 2014-02-12 17:49
There's no patch attached... or am I just confused?
msg211109 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2014-02-12 17:49
Forgot to attach the patch...
msg211110 - (view) Author: Stephan R.A. Deibel (sdeibel) Date: 2014-02-12 18:40
Yes, thanks, that patch fixes it so it builds successfully.  Tried w/ Python 3.4rc1 on Windows 7 w/ VS2010.

Of course maybe it should really be building kill_python.exe for the matching architecture and running that, but I'm not sure how to do that and your fix is certainly far better than current behavior.
msg211116 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2014-02-12 21:19
> Yes, thanks, that patch fixes it so it builds successfully.  Tried w/
> Python 3.4rc1 on Windows 7 w/ VS2010.

Ok, good.

> Of course maybe it should really be building kill_python.exe for the
> matching architecture and running that, but I'm not sure how to do that
> and your fix is certainly far better than current behavior.

kill_python(_d).exe looks for a Python from the same directory as it is run from (with the same debug status) which should always mean that if kill_python(_d).exe can't run, neither can the Python it would look for.  My goal with this patch is to make running kill_python a "best effort" thing and make it obvious when it didn't run properly, without killing the build.  If it should have run but wasn't able to, there will be louder errors later on, and the warning from the attempt to run it should help point out what went wrong.
msg211117 - (view) Author: Stephan R.A. Deibel (sdeibel) Date: 2014-02-12 22:27
OK, sounds reasonable to me.
msg211526 - (view) Author: Roundup Robot (python-dev) Date: 2014-02-18 17:35
New changeset d610a2740b5f by Zachary Ware in branch '3.3':
Issue #20609: Fix building 64-bit binaries on 32-bit Windows.
http://hg.python.org/cpython/rev/d610a2740b5f

New changeset 69d13cdc4eeb by Zachary Ware in branch 'default':
Issue #20609: Merge with 3.3.
http://hg.python.org/cpython/rev/69d13cdc4eeb
msg211527 - (view) Author: Zachary Ware (zach.ware) * (Python committer) Date: 2014-02-18 17:36
Fixed, thanks for the report!
msg213820 - (view) Author: Roundup Robot (python-dev) Date: 2014-03-17 06:31
New changeset 6b4225607cf1 by Zachary Ware in branch '3.4':
Issue #20609: Merge with 3.3.
http://hg.python.org/cpython/rev/6b4225607cf1
History
Date User Action Args
2014-03-17 06:31:00python-devsetmessages: + msg213820
2014-02-18 17:36:01zach.waresetstatus: open -> closed
messages: + msg211527

assignee: zach.ware
resolution: fixed
stage: resolved
2014-02-18 17:35:27python-devsetnosy: + python-dev
messages: + msg211526
2014-02-12 22:27:40sdeibelsetmessages: + msg211117
2014-02-12 21:19:57zach.waresetmessages: + msg211116
2014-02-12 18:40:12sdeibelsetmessages: + msg211110
2014-02-12 17:49:24zach.waresetfiles: + issue20609.diff
keywords: + patch
messages: + msg211109
2014-02-12 17:49:02sdeibelsetmessages: + msg211108
2014-02-12 17:37:55zach.waresetnosy: + tim.peters

messages: + msg211107
versions: + Python 3.3
2014-02-12 14:27:47zach.waresetnosy: + zach.ware
2014-02-12 14:26:55sdeibelcreate